catch_sfx=loadsfx('$MISSION/catch.wav')
near_sfx=loadsfx('$MISSION/near.wav')
break_sfx=loadsfx('$MISSION/break.wav')
flashlight_sfx=loadsfx('$MISSION/flashlight.wav')
flashlight_gfx=loadgfx('$MISSION/flashlight.png')
setmidhandle(flashlight_gfx)
light_gfx=loadgfx('$MISSION/light.png')
setmidhandle(light_gfx)
dark_gfx=loadgfx('$MISSION/dot.png')
slendy_gfx=loadgfx('$MISSION/slenderman.png')
setmidhandle(slendy_gfx)
face_gfx=loadgfx('$MISSION/face.png')
static_gfx={}
static_gfx[0]=loadgfx('$MISSION/static0.png')
static_gfx[1]=loadgfx('$MISSION/static1.png')
static_gfx[2]=loadgfx('$MISSION/static2.png')
static_gfx[3]=loadgfx('$MISSION/static3.png')

caught=0
supplies=0
supiew=150
slendy_x=getmapwidth()/2
slendy_y=getwatery()+getmapheight()
static_alpha=0
dark_alpha=0.99
blood=0
switch=1
battery=5000
swimmer=30
s1=math.random(0,2)
s2=math.random(3,6)
s3=math.random(7,9)
s4=math.random(10,11)
s5=math.random(12,14)
timer=50*(60-(supplies*10))
maxtimer=timer

function mission_start()
	-- Spawn Crates
	createobject(zj.zuflay.id,getnodex(s1),getnodey(s1))
	createobject(zj.zuflay.id,getnodex(s2),getnodey(s2))
	createobject(zj.zuflay.id,getnodex(s3),getnodey(s3))
	createobject(zj.zuflay.id,getnodex(s4),getnodey(s4))
	createobject(zj.zuflay.id,getnodex(s5),getnodey(s5))
	-- Blood
	terrainalphaimage(gfx_blood50,getnodex("drop1"),getnodey("drop1"),1.0,255,0,0)
	terrainalphaimage(gfx_blood50,getnodex("drop2"),getnodey("drop2"),1.0,255,0,0)
	terrainalphaimage(gfx_blood50,getnodex("drop3"),getnodey("drop3"),1.0,255,0,0)
	terrainalphaimage(gfx_blood50,getnodex("drop4"),getnodey("drop4"),1.0,255,0,0)
	terrainalphaimage(gfx_blood50,getnodex("drop5"),getnodey("drop5"),1.0,255,0,0)
	terrainalphaimage(gfx_blood50,getnodex("drop6"),getnodey("drop6"),1.0,255,0,0)
	terrainalphaimage(gfx_blood50,getnodex("drop7"),getnodey("drop7"),1.0,255,0,0)
	terrainalphaimage(gfx_blood50,getnodex("drop8"),getnodey("drop8"),1.0,255,0,0)
	-- Remove Fire
	fire=objecttable(o_fire)
	for f=1,#fire do
		removeobject(fire[f])
	end
end
function mission_draw()
	-- Blood
	if getnodex("day")~=0 then
		blood=blood+1
		if blood>=100 then
			particle(p_blooddrop,getnodex("drop1"),getnodey("drop1"))
			particlecolor(255,0,0)
			particle(p_blooddrop,getnodex("drop2"),getnodey("drop2"))
			particlecolor(255,0,0)
			particle(p_blooddrop,getnodex("drop3"),getnodey("drop3"))
			particlecolor(255,0,0)
			particle(p_blooddrop,getnodex("drop4"),getnodey("drop4"))
			particlecolor(255,0,0)
			particle(p_blooddrop,getnodex("drop5"),getnodey("drop5"))
			particlecolor(255,0,0)
			particle(p_blooddrop,getnodex("drop6"),getnodey("drop6"))
			particlecolor(255,0,0)
			particle(p_blooddrop,getnodex("drop7"),getnodey("drop7"))
			particlecolor(255,0,0)
			particle(p_blooddrop,getnodex("drop8"),getnodey("drop8"))
			particlecolor(255,0,0)
			blood=0
		end
	end
	-- Draw Flashlight
	if getnodex("day")==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(0.7,0.7)
		setrotation(getplayerrotation(0))
		drawimage(flashlight_gfx,getplayerx(0)+(6*getplayerdirection(0)),getplayery(0)+3)
	end
	-- Draw Slenderman
	if caught==1 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setrotation(0)
		if getplayerx(0)>=slendy_x then
			setscale(1,1.1)
		else
			setscale(-1,1.1)
		end
		drawimage(slendy_gfx,slendy_x,slendy_y-4)
	end
	if getnodex("day")==0 then
		-- Draw Darkness
		-- Draw Light
		if weapon_mode==0 then
			if switch==1 then
				setblend(blend_alpha)
				setalpha(dark_alpha)
				setcolor(255,255,255)
				setscale(1,1)
				setrotation(getplayerrotation(0))
				drawimage(light_gfx,getplayerx(0)+(6*getplayerdirection(0)),getplayery(0)+3)
			else
				setblend(blend_alpha)
				setalpha(dark_alpha)
				setcolor(0,0,0)
				setscale(2000,2000)
				setrotation(0)
				drawimage(dark_gfx,(getplayerx(0)+(6*getplayerdirection(0)))-1000,(getplayery(0)+3)-1000)
			end
		end
	end
	-- Draw Static
	if static_alpha>0 then
		if static_alpha>=0.8 then
			setblend(blend_alpha)
			setscale((1/960)*screenwidth(),(1/720)*screenheight())
			setalpha(1)
			setcolor(255,255,255)
			setrotation(0)
			drawhud(face_gfx,0,0,1)
		end
		if static_alpha>=0.8 then
			setblend(blend_light)
		else
			setblend(blend_alpha)
		end
		setscale((1/800)*screenwidth(),(1/600)*screenheight())
		if static_alpha>=0.8 then
				setalpha(0.5)
			else
				setalpha(static_alpha)
		end
		setcolor(255,255,255)
		setrotation(0)
		drawhud(static_gfx[math.random(0,3)],0,0,1)
	end
	-- Supply Count
	if supiew>0 then
		supiew=supiew-1
		hudinfo(supplies.."/5 Crates")
	end
end
function mission_update()
	-- Background Color
	if getnodex("day")==0 then
		setbgcolor(10,10,30,dark_alpha)
	else
		setbgcolor(130,150,255,dark_alpha)
	end
	-- Timer
	timer=timer-1
	-- Music
	if timer<maxtimer/2 and timer>50 then
		if channelplaying(7)==0 then
			playsound(near_sfx,7,2.0)
		end
	end
	-- Check Time
	if timer<=0 then
		for col=1,5 do
			if collision(colplayer,getplayerx(0)+(((col*5)-3)*getplayerdirection(0)),getplayery(0),1,1,1,-1,id)==0 then
				if channelplaying(9)==0 and getplayerhealth(0)>0 and static_alpha<0.5 then
					playsound(catch_sfx,9,2.0)
				end
				caught=1
			end
		end
	end
	-- Player Lost
	if caught==1 then
		playercontrol(0)
		static_blend()
		slendy_x=getplayerx(0)+(22*getplayerdirection(0))
		slendy_y=getplayery(0)
		playerpush(0,0,0,1)
		playerforceframe(0,1)
		playerdamage(0,0)
	end
	-- Player Won
	if supplies>=5 then
		playercontrol(0)
		cutscene()
		dark_alpha=dark_alpha-0.0067
		if dark_alpha<=0 then
			win()
		end
	end
	-- Flashlight
	if getnodex("day")==0 then
		if swimmer>0 then
			swimmer=swimmer-1
		end
		if keydown(key_attack)==1 and swimmer<=0 then
			playsound(flashlight_sfx)
			if switch==0 and battery>0 then
				switch=1 
			elseif switch==1 then
				switch=0
			end
			swimmer=30
		end
		if switch==1 then
			battery=battery-1
			if battery<=0 then
				playsound(break_sfx,-1,2.5)
				switch=0
			end
		elseif switch==0 and battery>0 then
			if battery<5000 then
				battery=battery+5
			end
		end
		if battery>5000 then
			battery=5000
		end
	end
	-- Forceframe
	if getplayeraction(0)~=0 then
		playerforceframe(0,2)
	end
	scroll(getplayerx(0),getplayery(0))
end
function static_blend()
	-- Static
	cutscene()
	static_alpha=static_alpha+0.009
	if static_alpha>=0.9 then
		static_kill()
	end
end
function static_kill()
	-- Kill Player
	if getplayerhealth(0)>0 then
		playerheal(0,2147483648)
	end
end

if zj==nil then zj={} end
zj.zuflay={}
zj.zuflay.gfx=loadgfx('$MISSION/supply.png')
setmidhandle(zj.zuflay.gfx)
zj.zuflay.gfx2=loadgfx("flare1.bmp")
setmidhandle(zj.zuflay.gfx2)
zj.zuflay.sfx=loadsfx("supplycollect.ogg")
zj.zuflay.id=addobject("zj.zuflay",0)
function zj.zuflay.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].sy=0
end
function zj.zuflay.draw(id,x,y)
	-- Draw Light
	setblend(blend_light)
	setalpha(1)
	setcolor(0,255,0)
	setscale(0.5,0.5)
	setrotation(80)
	drawimage(zj.zuflay.gfx2,x,y)
	-- Draw Crate
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1.2-math.abs(math.sin(id*10+os.clock()*2))*0.2,1+math.abs(math.sin(id*10+os.clock()*2))*0.3)
	setrotation(0)
	drawimage(zj.zuflay.gfx,x,y)
end
function zj.zuflay.update(id,x,y)
	-- Fall
	objects[id].sy=objects[id].sy+getgravity()*5
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(zj.zuflay.gfx,x,y,1,1,1,-1,id)==1 then
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.1
			msuby=-msuby*0.1
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
	-- Check Collection
	if collision(zj.zuflay.gfx,x,y,1,1,1,-1,id)==1 then
		if playercollision()~=0 then
			-- Reset Timer
			supplies=supplies+1
			supiew=150
			timer=50*(60-(supplies*10))
			maxtimer=timer
			playsound(zj.zuflay.sfx)
			-- Effect
			particle(p_muzzle,x,y)
			particlesize(0.9,0.9)
			particlerotation(0)
			particlealpha(1.0)
			particlefadealpha(0.04)
			particlecolor(0,255,0)
			for i=1,10 do
				particle(p_flare,x+math.random(-1000,1000)/100,y+math.random(-1000,1000)/100)
				size=math.random(200,500)/100
				particlesize(size,size)
				particlefadealpha(math.random(10,20)/1000)
				particlecolor(0,255,0)
				particlespeed(0,-math.random(20,150)/100)
			end
			-- Remove
			removeobject(id)
			return 1
		end
	end
end
function zj.zuflay.damage(id,damage)
end